require_relative '../spec_helper.rb'

describe Lita::Handlers::Lister, lita_handler: true, additional_lita_handlers: Lita::Handlers::AbstractHandler do

  #SUCCCESSFULL COMMANDS
  it "order to list the stacks with 'list all'" do
    send_command("list all")
    expect(replies).to eq([{:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_busy* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_good* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_wait_loop* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*good_to_good_forever_stack* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*pm-busy_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-good_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagelast-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagesecond-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

  it "order to list the stacks with 'list'" do
    send_command("list")
    expect(replies).to eq([{:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_busy* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_good* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_wait_loop* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*good_to_good_forever_stack* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*pm-busy_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-good_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagelast-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagesecond-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

  it "order to list the stacks with 'list stacks'" do
    send_command("list stacks")
    expect(replies).to eq([{:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_busy* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_good* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_wait_loop* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*good_to_good_forever_stack* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*pm-busy_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-good_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagelast-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagesecond-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

  it "order to list the stacks with 'list all stacks'" do
    send_command("list all stacks")
    expect(replies).to eq([{:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_busy* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_good* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_wait_loop* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*good_to_good_forever_stack* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*pm-busy_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-good_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagelast-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagesecond-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

  it "order to list a particular existing stack" do
    send_command("list -s pm-stagefirst-drupal")
    expect(replies).to eq([{:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

  it "order to list a particular non-existing stack" do
    send_command("list -s pm-stage-drupal")
    expect(replies).to eq([{:title=>"No matching stacks", :text=>nil, :color=>"", :fallback=>"No matching stacks", :mrkdwn_in=>["text"], :pretext=>nil}])
  end

  it "order to display the help for the list command" do
    send_command("list -h")
    expect(replies.first[:title]).to match(/Help for list/)
  end

  #SPAMMING COMMANDS
  it "order to list the stacks with 'list all'" do
    for i in 0..4
      send_command("list all stacks")
    end
    expect(replies.uniq).to eq([{:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_busy* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*busy_to_good_forever_stack_set_local_status_to_cancelling_good* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*busy_to_good_forever_stack_wait_loop* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*good_to_good_forever_stack* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>"#0000ff", :text=>"*pm-busy_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-good_stack-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagefirst-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagelast-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}, {:color=>:danger, :text=>"*pm-stagesecond-drupal* _production_ (Docker/DigitalOcean) *Last Activity:* _2016-10-20 10:32:10_", :mrkdwn_in=>["text"], :fallback=>"Listing stacks"}])
  end

end
